#include <GL/glut.h>
#include "nodes.h"


SGLight::SGLight(int index)
	:m_index(index)
{
	if(index<0 || index>7)
		throw("invalid light index");
}

void SGLight::predraw()
{
	SGNode::predraw();

	glEnable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);

	glLoadIdentity();
	glEnable(GL_LIGHT0+m_index);
	glLightfv( GL_LIGHT0+m_index, GL_POSITION, &globalmatrix.GetPtr()[12] );
}


SGCamera::SGCamera()
{
}

void SGCamera::predraw()
{
	SGNode::predraw();

	float at[3]={0,0,1}, up[3]={0,1,0};
	globalmatrix.TransformPoint(at);
	globalmatrix.TransformVector(up);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0f, 1, .1f , 100.0f);
	gluLookAt(	globalmatrix.GetPtr()[12],
				globalmatrix.GetPtr()[13],
				globalmatrix.GetPtr()[14],
				at[0], at[1], at[2],
				up[0], up[1], up[2]);
	glMatrixMode(GL_MODELVIEW);
}



SGCube::SGCube(bool solid, float size)
{
	m_solid = solid;
	m_size = size;
}

void SGCube::drawgeometry()
{
	if ( m_solid ) 
		glutSolidCube( m_size );
	else
		glutWireCube( m_size );
}


//Füllt diese Funktionen wie den Cube!
SGSphere::SGSphere(bool solid, float radius, int slices, int stacks)
{

}

void SGSphere::drawgeometry()
{

}

SGTeapot::SGTeapot(bool solid, float size)
{

}

void SGTeapot::drawgeometry()
{

}


